//#include <pp_crt.h>
#include <windows.h>
#include <vorbis/vorbisenc.h>
#include <commctrl.h>
#include "filters.h" 
#include "resource.h"

HINSTANCE hIns;

#define READ 1024

//note : for some reason (not so) cool edit doesn't get exports if they are only _declspec(dllexport)-ed; I've had to /export all the shit in linker options.

__declspec(dllexport) void PASCAL GetSuggestedSampleType(long* sr,short *bps,short *ch)
{
//	*ch=2;
	*sr=44100;
	*bps=16;
}

__declspec(dllexport) int PASCAL QueryCoolFilter(COOLQUERY far * cq)
{
	strcpy(cq->szName,"Ogg Vorbis");
	strcpy(cq->szCopyright,"http://www.vorbis.com/");
	strcpy(cq->szExt,"OGG");
	cq->lChunkSize=READ*4;
	cq->dwFlags=QF_CANSAVE|QF_HASOPTIONSBOX|QF_CANLOAD;
 	cq->Stereo8=0;
 	cq->Stereo16=R_22050|R_32075|R_44100|R_48000;
 	cq->Stereo24=0;
 	cq->Stereo32=0;
 	cq->Mono8=0;
 	cq->Mono16=R_22050|R_32075|R_44100|R_48000;
 	cq->Mono24=0;
 	cq->Mono32=0;
 	cq->Quad32=0;
 	cq->Quad16=R_22050|R_32075|R_44100|R_48000;;
 	cq->Quad8=0;
 	return C_VALIDLIBRARY;
}

typedef struct
{
  ogg_stream_state os; /* take physical pages, weld into a logical
			  stream of packets */
  ogg_page         og; /* one Ogg bitstream page.  Vorbis packets are inside */
  ogg_packet       op; /* one raw packet of data for decode */
  
  vorbis_info      vi; /* struct that stores all the static vorbis bitstream
			  settings */
  vorbis_comment   vc; /* struct that stores all the user comments */

  vorbis_dsp_state vd; /* central working state for the packet->PCM decoder */
  vorbis_block     vb; /* local working space for packet->PCM decode */
  HANDLE f;
  UINT nch;
} OUTPUT;


static UINT br_spin_ids[]={IDC_SPIN1,IDC_SPIN2,IDC_SPIN3,IDC_SPIN4};
static UINT radio_ids[3]={IDC_RADIO_VBR,IDC_RADIO_ABR,IDC_RADIO_CBR};

//cool edit's config system is shit

typedef struct
{
	char abr_use_max,abr_use_min;
	UINT mode;//=0;
	UINT vbrquality;//=600;
	UINT abr_nominal;//=160;
	UINT abr_max;//=320;
	UINT abr_min;//=1;
	UINT cbr;//=160;
} CFG;

static void unpack_cfg(CFG * cfg,DWORD dw)
{
	memset(cfg,0,sizeof(CFG));
	cfg->abr_nominal=160;
	cfg->abr_max=320;
	cfg->abr_min=1;
	cfg->cbr=160;
	cfg->vbrquality=600;
	switch(dw&3)
	{/*
	case 0:
		cfg->mode=0;
		cfg->vbrquality=600;
		break;*/
	case 1:
		//cfg->mode=0;
		cfg->vbrquality=(dw>>2);
		break;
	case 2:
		cfg->mode=1;
		cfg->abr_use_max=(dw&8)?1:0;
		cfg->abr_use_min=(dw&4)?1:0;
		cfg->abr_nominal=(dw>>4)&0x1FF;//9 bits, 512 max
		cfg->abr_max=(dw>>(4+9))&0x1FF;//9 bits
		cfg->abr_min=(dw>>(4+9+9))&0x1FF;//9 bits
		break;
	case 3:
		cfg->mode=2;
		cfg->cbr=(dw>>2);
		break;
	}
}

#define MIN(x,y) (x<y ? x : y)

static DWORD pack_cfg(const CFG* cfg)
{
	DWORD res=0;
	switch(cfg->mode)
	{
	case 0:
		res=1|(cfg->vbrquality<<2);
		break;
	case 1:
		res=2|(cfg->abr_use_max ? 4 : 0) | (cfg->abr_use_min ? 8 : 0) | (MIN(cfg->abr_nominal,511)<<4) | (MIN(cfg->abr_max,511)<<(4+9)) | (MIN(cfg->abr_min,511)<<(4+9+9));
		break;
	case 2:
		res=3|(cfg->cbr<<2);
		break;
	}
	return res;
}

static BOOL CALLBACK DlgProc(HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			CFG cfg;
			UINT n;
			HWND w;
			unpack_cfg(&cfg,lp);

			for(n=0;n<sizeof(br_spin_ids)/sizeof(br_spin_ids[0]);n++)
				SendDlgItemMessage(wnd,br_spin_ids[n],UDM_SETRANGE,0,MAKELONG(511,1));
			
			for(n=0;n<3;n++)
			{
				SendDlgItemMessage(wnd,radio_ids[n],BM_SETCHECK,n==cfg.mode ? BST_CHECKED : BST_UNCHECKED , 0);
			}
			
			SendDlgItemMessage(wnd,IDC_ABR_USE_MIN,BM_SETCHECK,cfg.abr_use_min,0);
			SendDlgItemMessage(wnd,IDC_ABR_USE_MAX,BM_SETCHECK,cfg.abr_use_max,0);
			SetDlgItemInt(wnd,IDC_ABR_NOMINAL,cfg.abr_nominal,0);
			SetDlgItemInt(wnd,IDC_ABR_MIN,cfg.abr_min,0);
			SetDlgItemInt(wnd,IDC_ABR_MAX,cfg.abr_max,0);
			SetDlgItemInt(wnd,IDC_CBR_BITRATE,cfg.cbr,0);

			w=GetDlgItem(wnd,IDC_VBRQUALITY);
			SendMessage(w,TBM_SETRANGE,0,MAKELONG(0,1100));
			SendMessage(w,TBM_SETPOS,1,cfg.vbrquality);
			DlgProc(wnd,WM_HSCROLL,0,(LPARAM)w);
		}
		return 1;
	case WM_HSCROLL:
		{
			int n=SendMessage((HWND)lp,TBM_GETPOS,0,0)-100;
			char zz[32];
			if (n<0) wsprintf(zz,"-%u.%02u",(-n)/100,(-n)%100);
			else wsprintf(zz,"%u.%02u",n/100,n%100);
			SetDlgItemText(wnd,IDC_VBR_DISP,zz);
		}
		break;
	case WM_COMMAND:
		switch(wp)
		{
		case IDC_RADIO_VBR:
		case IDC_RADIO_ABR:
		case IDC_RADIO_CBR:
			{
				UINT n;
				for(n=0;n<3;n++)
				{
					SendDlgItemMessage(wnd,radio_ids[n],BM_SETCHECK,wp==radio_ids[n] ? BST_CHECKED : BST_UNCHECKED,0);
				}
			}
			break;
		case IDCANCEL:
			EndDialog(wnd,0);
			break;
		case IDOK:
			{
				CFG cfg;
				
				UINT n;
				cfg.vbrquality=SendDlgItemMessage(wnd,IDC_VBRQUALITY,TBM_GETPOS,0,0);

				
				for(n=0;n<3;n++)
				{
					if (SendDlgItemMessage(wnd,radio_ids[n],BM_GETCHECK,0,0))
					{
						cfg.mode=n;
						break;
					}
				}

				cfg.abr_use_min=SendDlgItemMessage(wnd,IDC_ABR_USE_MIN,BM_GETCHECK,0,0);
				cfg.abr_use_max=SendDlgItemMessage(wnd,IDC_ABR_USE_MAX,BM_GETCHECK,0,0);
				cfg.abr_nominal=GetDlgItemInt(wnd,IDC_ABR_NOMINAL,0,0);
				cfg.abr_min=GetDlgItemInt(wnd,IDC_ABR_MIN,0,0);
				cfg.abr_max=GetDlgItemInt(wnd,IDC_ABR_MAX,0,0);
				cfg.cbr=GetDlgItemInt(wnd,IDC_CBR_BITRATE,0,0);
				if (cfg.abr_nominal==0) cfg.abr_nominal=1;
				if (cfg.abr_min==0) cfg.abr_min=1;
				if (cfg.abr_max==0) cfg.abr_max=1;
				if (cfg.cbr==0) cfg.cbr=1;

				EndDialog(wnd,pack_cfg(&cfg));
			}
			break;
		}		
		break;
	}
	return 0;
}

__declspec(dllexport) DWORD PASCAL FilterGetOptions(HWND hWnd, HINSTANCE hInst, long lSamprate, WORD wChannels, WORD wBitsPerSample, DWORD cfg)
{
	DWORD r=DialogBoxParam(hInst,(char*)IDD_DIALOG2,hWnd,DlgProc,cfg);
	return (r && r!=-1) ? r : cfg;
}

__declspec(dllexport) DWORD PASCAL FilterWriteSpecialData(HANDLE hOutput, LPCSTR szListType, LPCSTR szType, char * pData,DWORD dwSize)
{
	return 0;
}


__declspec(dllexport) OUTPUT* PASCAL OpenFilterOutput(LPSTR fn,long sr,WORD bps,WORD nch,long size, long *chunk, DWORD _cfg)
{
	CFG cfg;
	int poo;
	OUTPUT * o;
	o=(OUTPUT*)LocalAlloc(LMEM_FIXED|LMEM_ZEROINIT,sizeof(OUTPUT));
	if (!o) return 0;
	unpack_cfg(&cfg,_cfg);
	o->f=CreateFile(fn,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0);
	if (o->f==INVALID_HANDLE_VALUE)
	{
		LocalFree(o);
		return 0;
	}

	o->nch=nch;

	vorbis_info_init(&o->vi);
	if (cfg.mode==0) poo=vorbis_encode_init_vbr(&o->vi,nch,sr, (float)cfg.vbrquality*0.001-0.1);
	else
	{
		UINT nominal,min,max;
		if (cfg.mode==1)
		{//abr
			nominal=cfg.abr_nominal * 1000;
			min=cfg.abr_use_min ? cfg.abr_min * 1000: -1;
			max=cfg.abr_use_max ? cfg.abr_max * 1000: -1;
			
		}
		else//cbr
		{
			nominal=min=max=cfg.cbr*1000;
		}
		poo=vorbis_encode_init(&o->vi,nch,sr,max,nominal,min);
	}
	if (poo)
	{
		CloseHandle(o->f);
		DeleteFile(fn);
		vorbis_info_clear(&o->vi);
		LocalFree(o);
		return 0;
	}



  /* add a comment */
  vorbis_comment_init(&o->vc);
//  vorbis_comment_add(&o->vc,"Encoded using Cool Edit");

  /* set up the analysis state and auxiliary encoding storage */
  vorbis_analysis_init(&o->vd,&o->vi);
  vorbis_block_init(&o->vd,&o->vb);

  /* set up our packet->stream encoder */
  /* pick a random serial number; that way we can more likely build
	 chained streams just by concatenation */
  ogg_stream_init(&o->os,GetTickCount());

  /* Vorbis streams begin with three headers; the initial header (with
	 most of the codec setup parameters) which is mandated by the Ogg
	 bitstream spec.  The second header holds any comment fields.  The
	 third header holds the bitstream codebook.  We merely need to
	 make the headers, then pass them to libvorbis one at a time;
	 libvorbis handles the additional Ogg bitstream constraints */

  {
	ogg_packet header;
	ogg_packet header_comm;
	ogg_packet header_code;

	vorbis_analysis_headerout(&o->vd,&o->vc,&header,&header_comm,&header_code);
	ogg_stream_packetin(&o->os,&header); /* automatically placed in its own
					 page */
	ogg_stream_packetin(&o->os,&header_comm);
	ogg_stream_packetin(&o->os,&header_code);

	/* We don't have to write out here, but doing so makes streaming 
	 * much easier, so we do, flushing ALL pages. This ensures the actual
	 * audio data will start on a new page
	 */
	while(ogg_stream_flush(&o->os,&o->og)){
		DWORD bw;
		WriteFile(o->f,o->og.header,o->og.header_len,&bw,0);
		WriteFile(o->f,o->og.body,o->og.body_len,&bw,0);
	}

  }
  *chunk = READ * nch * (bps>>3);
  return o;
}


__declspec(dllexport) DWORD FAR PASCAL WriteFilterOutput(OUTPUT* o, short *rbuf, long bytes)
{
	if(bytes==0){
	  /* end of file.  this can be done implicitly in the mainline,
		 but it's easier to see here in non-clever fashion.
		 Tell the library we're at end of stream so that it can handle
		 the last frame and mark end of stream in the output properly */
	  vorbis_analysis_wrote(&o->vd,0);

	}else{
	  /* data to encode */

	  /* expose the buffer to submit data */
 
	  /* uninterleave samples */
	  UINT nsam=bytes/(2*o->nch);
	  UINT i,c;
	  float **buffer=vorbis_analysis_buffer(&o->vd,nsam);
	  for(i=0;i<nsam;i++)
	  {
		  for(c=0;c<o->nch;c++)
		  {
			  buffer[c][i]=(float)rbuf[i*o->nch+c]/32768.f;
		  }
	  }    
	  /* tell the library how much we actually submitted */
	  vorbis_analysis_wrote(&o->vd,nsam);
	}

	/* vorbis does some data preanalysis, then divvies up blocks for
	   more involved (potentially parallel) processing.  Get a single
	   block for encoding now */
	while(vorbis_analysis_blockout(&o->vd,&o->vb)==1){

	  /* analysis */
	  vorbis_analysis(&o->vb,&o->op);
  
	  vorbis_bitrate_addblock(&o->vb);

		while(vorbis_bitrate_flushpacket(&o->vd, &o->op))
		{

			/* weld the packet into the bitstream */
			ogg_stream_packetin(&o->os,&o->op);

			/* write out pages (if any) */
			while(ogg_stream_pageout(&o->os,&o->og)){
				DWORD bw;
				WriteFile(o->f,o->og.header,o->og.header_len,&bw,0);
				WriteFile(o->f,o->og.body,o->og.body_len,&bw,0);
			}
		}
	}

	return bytes;
}

__declspec(dllexport) void FAR PASCAL CloseFilterOutput(OUTPUT* o)
{
	WriteFilterOutput(o,0,0);

	CloseHandle(o->f);
  /* clean up and exit.  vorbis_info_clear() must be called last */

	  ogg_stream_clear(&o->os);
	  vorbis_block_clear(&o->vb);
	  vorbis_dsp_clear(&o->vd);
	  vorbis_comment_clear(&o->vc);
	  vorbis_info_clear(&o->vi);

	LocalFree(o);
}
